// PlusScriptDLLExample.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "PlusScriptDLLExample.h"

#include <string>
#include <sstream>
#include <map>

#import "C:\Program Files (x86)\Messenger Plus! Live\MsgPlusLive.dll" tlbid(1)

#define DLLCALL_INT extern "C" __declspec(dllexport) int __stdcall

using namespace MPLiveScriptingLib;
_IMPMsgPlusPtr pMsgPlus;
_IMPMessengerPtr pMessenger;
_IMPDebugPtr pDebug;

LRESULT newChatWindowProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
std::map<HWND, WNDPROC> wndProcMap;

template<typename IPtr>
HRESULT acquireInterfacePtr(IDispatch* pDispatch, IPtr& ptr){
    IPtr::Interface* raw;
    HRESULT hr;

    if(SUCCEEDED(hr = pDispatch->QueryInterface(&raw))){
        ptr.Attach(raw);
    }

    return hr;
}

DLLCALL_INT init(IDispatch* dispMsgPlus, IDispatch* dispMessenger, IDispatch* dispDebug){
	acquireInterfacePtr(dispMsgPlus, pMsgPlus);
	acquireInterfacePtr(dispMessenger, pMessenger);
	acquireInterfacePtr(dispDebug, pDebug);

	return 0;
}

DLLCALL_INT signinready(){
	IDispatchPtr dispContacts = pMessenger->GetMyContacts();
	_IMPContactsPtr pContacts;

	acquireInterfacePtr(dispContacts, pContacts);

	IEnumVARIANT *pEnumVariant;
	IUnknownPtr pUnknown = pContacts->Get_NewEnum();
	pUnknown->QueryInterface(&pEnumVariant);

	VARIANT var;
	VariantInit(&var);

	int n = 0;
	while(pEnumVariant->Next(1, &var, NULL) == S_OK && n < 10){
		IDispatch* pDispatch = V_DISPATCH(&var);
		
		_IMPContactPtr pContact;
		acquireInterfacePtr(pDispatch, pContact);

		_bstr_t email = pContact->GetEmail();
		STATUS status = pContact->GetSTATUS();

		std::wostringstream stream;
		stream << L"[" << email << L"]" << L" status: " << status;

		pDebug->Trace(stream.str().c_str());

		VariantClear(&var);
		n++;
	}

	pEnumVariant->Release();

	return 0;
}

DLLCALL_INT attachchatwindow(IDispatch* dispChatWnd){
	_IMPChatWndPtr pChatWnd;
	acquireInterfacePtr(dispChatWnd, pChatWnd);

	HWND hwndChatWnd = reinterpret_cast<HWND>(pChatWnd->GetHandle());

	wndProcMap.insert(std::map<HWND, WNDPROC>::value_type(hwndChatWnd, reinterpret_cast<WNDPROC>(GetWindowLongPtr(hwndChatWnd, GWLP_WNDPROC))));

	SetWindowLongPtr(hwndChatWnd, GWLP_WNDPROC, reinterpret_cast<LONG_PTR>(newChatWindowProc));

	return 0;
}

LRESULT newChatWindowProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam){
	std::map<HWND, WNDPROC>::iterator iter;
	iter = wndProcMap.find(hwnd);

	if(msg == WM_SIZE){
		int width = LOWORD(lparam);
		int height = HIWORD(lparam);

		TCHAR title[1024] = {0};
		GetWindowText(hwnd, title, 1023);

		std::wostringstream stream;
		stream << L"[" << title << L" (" << std::hex << hwnd << std::dec << ")]" << L" width: " << width << ", height: " << height;

		pDebug->Trace(stream.str().c_str());
	}else if(msg == WM_DESTROY){
		if(iter != wndProcMap.end()){
			SetWindowLongPtr(hwnd, GWLP_WNDPROC, reinterpret_cast<LONG_PTR>(iter->second));
		}
	}

	if(iter == wndProcMap.end()){
		return FALSE;
	}else{
		return CallWindowProc(reinterpret_cast<WNDPROC>(iter->second), hwnd, msg, wparam, lparam);
	}
}